server {
    # Listen on port 80
    listen        *:80 default_server;
    # The virtualhost is our domain name
    server_name   "{{ inventory_hostname }}";

    # Our log files will go here.
    access_log  /var/log/nginx/access.log;
    error_log   /var/log/nginx/error.log;

    # The most important location block, by default all requests are sent to uWSGI
    location / {
        # This is the backend to send the requests to.
        uwsgi_pass {{ galaxy_config.uwsgi.socket }};
        uwsgi_param UWSGI_SCHEME $scheme;
        include uwsgi_params;
    }

    # Static files can be more efficiently served by Nginx. Why send the
    # request to uWSGI which should be spending its time doing more useful
    # things like serving Galaxy!
    location /static {
        alias {{ galaxy_server_dir }}/static;
        expires 24h;
    }

    # In Galaxy instances started with run.sh, many config files are
    # automatically copied around. The welcome page is one of them. In
    # production, this step is skipped, so we will manually alias that.
    location /static/welcome.html {
        alias {{ galaxy_server_dir }}/static/welcome.html.sample;
        expires 24h;
    }

    # serve visualization and interactive environment plugin static content
    location ~ ^/plugins/(?<plug_type>[^/]+?)/((?<vis_d>[^/_]*)_?)?(?<vis_name>[^/]*?)/static/(?<static_file>.*?)$ {
        alias {{ galaxy_server_dir }}/config/plugins/$plug_type/;
        try_files $vis_d/${vis_d}_${vis_name}/static/$static_file
                  $vis_d/static/$static_file =404;
    }

    location /robots.txt {
        alias {{ galaxy_server_dir }}/static/robots.txt;
    }

    location /favicon.ico {
        alias {{ galaxy_server_dir }}/static/favicon.ico;
    }

    location /_x_accel_redirect {
        internal;
        alias /;
    }

    # Support click-to-run in the GTN-in-Galaxy Webhook
    location /training-material/ {
        proxy_pass https://training.galaxyproject.org/training-material/;
    }
}
